/*
  Lapplication class
*/
#include "hbclass.ch"
#include "common.ch"

MEMVAR windows

FUNCTION LStart()

 IF !__mvEXIST( "windows" )
  __mvPUBLIC( "windows" )
 ENDIF

 windows := LAPPLICATION():New()
 
RETURN NIL

CLASS LAPPLICATION

 CLASS VAR lQtStarted                           INIT .F.      SHARED
 CLASS VAR sQtApplication                       INIT NIL      SHARED
 CLASS VAR sQtResource                          INIT NIL      SHARED
 CLASS VAR aQtResource                          INIT {}       SHARED

 CLASS VAR oApplParent                          INIT NIL      SHARED
 CLASS VAR oDefaultParent                       INIT NIL      SHARED
 CLASS VAR nObjectCounter                       INIT 0        SHARED
 CLASS VAR lMainForm                            INIT .F.      SHARED
 CLASS VAR lStdError                            INIT .F.      SHARED

// Properties
 METHOD Font
 METHOD FontName
 METHOD FontSize
 METHOD FontBold                                INLINE .F.
 METHOD FontItalic                              INLINE .F.
 METHOD FontUnderLine                           INLINE .F.
 METHOD FontStrikeout                           INLINE .F.
 METHOD Name                                    INLINE "windows"
 METHOD QtObject                                INLINE NIL

// Methods
 METHOD AddForm
 METHOD New
 METHOD Quit
 METHOD RegisterResource
 METHOD UnRegisterResources

ENDCLASS

/*................................................................
 Properties - section
 ................................................................*/

/*---------------------------------------------------------------
 Font
 ---------------------------------------------------------------*/
METHOD LAPPLICATION:Font()

  IF ::lQtStarted == .T.
   RETURN QFont()
  ENDIF

RETURN NIL

/*---------------------------------------------------------------
 FontName
 ---------------------------------------------------------------*/
METHOD LAPPLICATION:FontName()

 LOCAL oFont

 IF ::lQtStarted == .T.
  oFont := QFont()
  RETURN oFont:Family()
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 FontSize
 ---------------------------------------------------------------*/
METHOD LAPPLICATION:FontSize()

 LOCAL oFont

 IF ::lQtStarted == .T.
  oFont := QFont()
  RETURN oFont:pixelSize()
 ENDIF

RETURN NIL

/*................................................................
 Methods - section
 ................................................................*/

/*---------------------------------------------------------------
 AddForm
 ---------------------------------------------------------------*/
METHOD LAPPLICATION:AddForm( cName, oObject )

 __objAddData( Self, cName )

 ::&cName := oObject

RETURN NIL


/*---------------------------------------------------------------
 New
 ---------------------------------------------------------------*/
METHOD LAPPLICATION:New()

 LOCAL cPath, cFile, cExt

 hb_FnameSplit( hb_Progname(), @cPath, @cFile, @cExt )

 IF ::lQtStarted == .F.
  ::sQtApplication := QApplication()
  ::lQtStarted     := .T.
  ::oApplParent    := Self
  ::sQtResource    := QResource()
  ::RegisterResource( cFile )
 ENDIF

RETURN Self

/*---------------------------------------------------------------
 Quit
 ---------------------------------------------------------------*/
METHOD LAPPLICATION:Quit()

 IF ::lQtStarted == .T.
  ::UnRegisterResources()
  ::sQtApplication:Exit()
  ::sQtApplication:Quit()
  __mvXRELEASE( "windows" )
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 RegisterResource
 ---------------------------------------------------------------*/
METHOD LAPPLICATION:RegisterResource( cResource )

 LOCAL cResFileName := "HBQTRES_" + ALLTRIM( cResource ) + "()"

 IF TYPE( cResFileName ) == "UI"
  ::sQtResource:registerResource_1( &cResFileName )
  AADD( ::aQtResource, cResFileName )
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 UnRegisterResources
 ---------------------------------------------------------------*/
METHOD LAPPLICATION:UnRegisterResources()

 LOCAL nI, cResFileName

 FOR nI := 1 TO LEN( ::aQtResource )
  cResFileName := ::aQtResource[ nI ]
  ::sQtResource:unregisterResource_1( &cResFileName )
 NEXT nI

 ASIZE( ::aQtResource, 0 )

RETURN NIL
