/*
  Lcore class
*/
#include "hbclass.ch"
#include "common.ch"
#include "hbqtgui.ch"

CLASS LCORE

 DATA oQtObject                                 INIT NIL
 DATA lQtObject                                 INIT .F.

// generic Data
 DATA cCaption                                  INIT NIL
 DATA nCol                                      INIT NIL
 DATA aControls                                 INIT {}
 DATA nDirection                                INIT Qt_AlignAbsolute
 DATA oFont                                     INIT QFont()
 DATA cFontName                                 INIT NIL
 DATA nFontSize                                 INIT NIL
 DATA lFontBold                                 INIT NIL
 DATA lFontItalic                               INIT NIL
 DATA lFontUnderLine                            INIT NIL
 DATA lFontStrikeout                            INIT NIL
 DATA nFormType                                 INIT NIL
 DATA nHalign                                   INIT Qt_AlignHCenter
 DATA nHeight                                   INIT NIL
 DATA cIcon                                     INIT NIL
 DATA cName                                     INIT NIL
 DATA bOnInit                                   INIT NIL
 DATA bOnRelease                                INIT NIL
 DATA oParent                                   INIT NIL
 DATA nRow                                      INIT NIL
 DATA cStyleSheet                               INIT NIL
 DATA oSystemTrayIcon                           INIT NIL
 DATA cTitle                                    INIT NIL
 DATA nValign                                   INIT Qt_AlignVCenter
 DATA nWidth                                    INIT NIL

// generic Properties
 METHOD Caption                                 SETGET
 METHOD Col                                     SETGET
 METHOD Font                                    SETGET
 METHOD FontName                                SETGET
 METHOD FontSize                                SETGET
 METHOD FontBold                                SETGET
 METHOD FontItalic                              SETGET
 METHOD FontUnderLine                           SETGET
 METHOD FontStrikeout                           SETGET
 METHOD Height                                  SETGET
 METHOD Name                                    SETGET
 METHOD Row                                     SETGET
 METHOD StyleSheet                              SETGET
 METHOD Width                                   SETGET

// generic Events

// generic Methods
 METHOD Center
 METHOD QtObject

ENDCLASS

/*................................................................
 Properties - section
 ................................................................*/

/*---------------------------------------------------------------
 StyleSheet
 ---------------------------------------------------------------*/
METHOD LCORE:StyleSheet( cArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::cStyleSheet
  ELSEIF VALTYPE( cArg1 ) == "C"
   ::cStyleSheet := cArg1
   ::oQTObject:setStyleSheet( ::cStyleSheet )
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::cStyleSheet
  ELSEIF VALTYPE( cArg1 ) == "C"
   ::cStyleSheet := cArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Caption
 ---------------------------------------------------------------*/
METHOD LCORE:Caption( cArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::oQTObject:Text()
  ELSEIF VALTYPE( cArg1 ) == "C"
   ::cCaption := cArg1
   ::oQTObject:setText( ::cCaption )
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::cCaption
  ELSEIF VALTYPE( cArg1 ) == "C"
   ::cCaption := cArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Col
 ---------------------------------------------------------------*/
METHOD LCORE:Col( nArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::oQTObject:x()
  ELSEIF VALTYPE( nArg1 ) == "N"
   ::nCol := nArg1
   ::oQTObject:move( ::nCol, ::oQTObject:y() )
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::nCol
  ELSEIF VALTYPE( nArg1 ) == "N"
   ::nCol := nArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Font
 ---------------------------------------------------------------*/
METHOD LCORE:Font( oArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::oFont
  ELSEIF VALTYPE( oArg1 ) == "O"
   ::oFont := oArg1
   ::oQTObject:SetFont( ::oFont )
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::oFont
  ELSEIF VALTYPE( oArg1 ) == "O"
   ::oFont := oArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 FontName
 ---------------------------------------------------------------*/
METHOD LCORE:FontName( cArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::oFont:Family()
  ELSEIF VALTYPE( cArg1 ) == "C"
   ::cFontName := cArg1
   ::oFont:SetFamily( ::cFontName )
   ::oQTObject:SetFont( ::oFont )
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::cFontName
  ELSEIF VALTYPE( cArg1 ) == "C"
   ::cFontName := cArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 FontSize
 ---------------------------------------------------------------*/
METHOD LCORE:FontSize( nArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::oFont:PointSize()
  ELSEIF VALTYPE( nArg1 ) == "N"
   ::nFontSize := nArg1
   ::oFont:SetPointSize( ::nFontSize )
   ::oQTObject:SetFont( ::oFont )
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::nFontSize
  ELSEIF VALTYPE( nArg1 ) == "N"
   ::nFontSize := nArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 FontBold
 ---------------------------------------------------------------*/
METHOD LCORE:FontBold( lArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::oFont:Bold()
  ELSEIF VALTYPE( lArg1 ) == "L"
   ::lFontBold := lArg1
   ::oFont:SetBold( ::lFontBold )
   ::oQTObject:SetFont( ::oFont )
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::lFontBold
  ELSEIF VALTYPE( lArg1 ) == "L"
   ::lFontBold := lArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 FontItalic
 ---------------------------------------------------------------*/
METHOD LCORE:FontItalic( lArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::oFont:Italic()
  ELSEIF VALTYPE( lArg1 ) == "L"
   ::lFontItalic := lArg1
   ::oFont:SetItalic( ::lFontItalic )
   ::oQTObject:SetFont( ::oFont )
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::lFontItalic
  ELSEIF VALTYPE( lArg1 ) == "L"
   ::lFontItalic := lArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 FontUnderLine
 ---------------------------------------------------------------*/
METHOD LCORE:FontUnderLine( lArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::oFont:UnderLine()
  ELSEIF VALTYPE( lArg1 ) == "L"
   ::lFontUnderLine := lArg1
   ::oFont:SetUnderLine( ::lFontUnderLine )
   ::oQTObject:SetFont( ::oFont )
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::lFontUnderLine
  ELSEIF VALTYPE( lArg1 ) == "L"
   ::lFontUnderLine := lArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 FontStrikeOut
 ---------------------------------------------------------------*/
METHOD LCORE:FontStrikeOut( lArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::oFont:StrikeOut()
  ELSEIF VALTYPE( lArg1 ) == "L"
   ::lFontStrikeOut := lArg1
   ::oFont:SetStrikeOut( ::lFontStrikeOut )
   ::oQTObject:SetFont( ::oFont )
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::lFontStrikeOut
  ELSEIF VALTYPE( lArg1 ) == "L"
   ::lFontStrikeOut := lArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Height
 ---------------------------------------------------------------*/
METHOD LCORE:Height( nArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::oQTObject:Height()
  ELSEIF VALTYPE( nArg1 ) == "N"
   ::nHeight := nArg1
   ::oQTObject:resize( ::oQTObject:Width, ::nHeight )
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::nHeight
  ELSEIF VALTYPE( nArg1 ) == "N"
   ::nHeight := nArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Name
 ---------------------------------------------------------------*/
METHOD LCORE:Name( cArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::cName
  ELSEIF VALTYPE( cArg1 ) == "C"
/* nothing to do QT object created */
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::cName
  ELSEIF VALTYPE( cArg1 ) == "C"
   ::cName := cArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Row
 ---------------------------------------------------------------*/
METHOD LCORE:Row( nArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::oQTObject:y()
  ELSEIF VALTYPE( nArg1 ) == "N"
   ::nRow := nArg1
   ::oQTObject:move( ::oQTObject:x(), ::nRow )
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::nRow
  ELSEIF VALTYPE( nArg1 ) == "N"
   ::nRow := nArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Width
 ---------------------------------------------------------------*/
METHOD LCORE:Width( nArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::oQTObject:Width()
  ELSEIF VALTYPE( nArg1 ) == "N"
   ::nWidth := nArg1
   ::oQTObject:resize( ::nWidth, ::oQTObject:Height )
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::nWidth
  ELSEIF VALTYPE( nArg1 ) == "N"
   ::nWidth := nArg1
  ENDIF
 ENDIF

RETURN NIL

/*................................................................
 Methods - section
 ................................................................*/

/*---------------------------------------------------------------
 Center
 ---------------------------------------------------------------*/
METHOD LCORE:Center()

 LOCAL nFreeW, nFreeH

 IF ::lQtObject
  nFreeW := GetFreeWdWidth( ::oParent:QtObject() )
  nFreeH := GetFreeWdHeight( ::oParent:QtObject() )
  ::nRow := INT( ( nFreeH - ::nHeight ) / 2 )
  ::nCol := INT( ( nFreeW - ::nWidth ) / 2 )
  ::oQTObject:Move( ::nCol, ::nRow )
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Qtobject
 ---------------------------------------------------------------*/
METHOD LCORE:Qtobject()

 LOCAL oReturn

 oReturn := IF( ::lQtObject == .T., ::oQtObject, NIL )

RETURN oReturn
