/*
  Lcore class
*/
#include "hbclass.ch"
#include "common.ch"
#include "hbqtgui.ch"

#define LFRM_MAIN                               0
#define LFRM_STD                                1
#define LFRM_MODAL                              2
#define LFRM_FIRST_TYPE                         LFRM_MAIN
#define LFRM_LAST_TYPE                          LFRM_MODAL

CLASS LFORMS FROM LCORE, LAPPLICATION

// Properties
 METHOD Icon                                    SETGET
 METHOD OnInit                                  SETGET
 METHOD OnRelease                               SETGET
 METHOD Title                                   SETGET
 METHOD Type                                    SETGET

// Events

// Methods
 METHOD Activate
 METHOD AddObject
 METHOD Create
 METHOD CreatePendingChildControls
 METHOD New
 METHOD Release

ENDCLASS

/*................................................................
 Properties - section
 ................................................................*/

/*---------------------------------------------------------------
 Icon
 ---------------------------------------------------------------*/
METHOD LFORMS:Icon( cArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::cIcon
  ELSEIF VALTYPE( cArg1 ) == "C"
   ::cIcon := cArg1
   ::oQTObject:setWindowIcon( ::cIcon )
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::cIcon
  ELSEIF VALTYPE( cArg1 ) == "C"
   ::cIcon := cArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnInit
 ---------------------------------------------------------------*/
METHOD LFORMS:OnInit( bArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::bOnInit
  ELSEIF VALTYPE( bArg1 ) == "B"
/* nothing to do QtObject created */
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::bOnInit
  ELSEIF VALTYPE( bArg1 ) == "B"
   ::bOnInit := bArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 OnRelease
 ---------------------------------------------------------------*/
METHOD LFORMS:OnRelease( bArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::bOnRelease
  ELSEIF VALTYPE( bArg1 ) == "B"
/* nothing to do QtObject created */
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::bOnRelease
  ELSEIF VALTYPE( bArg1 ) == "B"
   ::bOnRelease := bArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Title
 ---------------------------------------------------------------*/
METHOD LFORMS:Title( cArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::cTitle
  ELSEIF VALTYPE( cArg1 ) == "C"
   ::cTitle := cArg1
   ::oQTObject:setWindowTitle( ::cTitle )
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::cTitle
  ELSEIF VALTYPE( cArg1 ) == "C"
   ::cTitle := cArg1
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Type
 ---------------------------------------------------------------*/
METHOD LFORMS:Type( nArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::nFormType
  ELSEIF VALTYPE( nArg1 ) == "N"
/* nothing to do QtObject created */
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::nFormType
  ELSEIF VALTYPE( nArg1 ) == "N"
   IF nArg1 >= LFRM_FIRST_TYPE .AND. nArg1 <= LFRM_LAST_TYPE
    DO CASE
     CASE nArg1 == LFRM_MAIN
      IF ::lMainForm == .F.
       ::lMainForm := .T.
       ::nFormType := nArg1
      ELSE
       MsgStop( "Main Form gi definita" )
       ::lStdError := .T.
      ENDIF
     OTHERWISE
      IF ::lMainForm == .F.
       MsgStop( "Main Form non definita" )
       ::lStdError := .T.
      ENDIF
    ENDCASE
   ELSE
    MsgStop( "Tipo Form non previsto" )
       ::lStdError := .T.
   ENDIF
  ENDIF
 ENDIF

RETURN NIL

/*................................................................
 Methods - section
 ................................................................*/

/*---------------------------------------------------------------
 Activate
 ---------------------------------------------------------------*/
METHOD LFORMS:Activate()

// Create QtObject Window
 IF ::lQtObject == .F.
  IF ::lStdError == .T.
   ::sQtApplication:Exit()
   ::sQtApplication:Quit()
  ELSE
   Self:Create()
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 AddObject
 ---------------------------------------------------------------*/
METHOD LFORMS:AddObject( cName, oObject )

 __objAddData( Self, cName )
 AADD( ::aControls, oObject )
 ::&cName := oObject

RETURN NIL

/*---------------------------------------------------------------
 Create
 ---------------------------------------------------------------*/
METHOD LFORMS:Create()

 IF ::lQtObject == .T.
  RETURN NIL
 ENDIF

 ::lQtObject := .T.
 // Create QtObject
 ::oQTObject := QMainWindow()

// setup font
 ::oFont := ::oParent:Font()
 IF VALTYPE( ::nCol )           != 'U'; Self:Col           := ::nCol           ; ENDIF
 IF VALTYPE( ::cFontName )      != 'U'; Self:FontName      := ::cFontName      ; ELSE ; Self:FontName      := ::oParent:FontName()      ; ENDIF
 IF VALTYPE( ::nFontSize )      != 'U'; Self:FontSize      := ::nFontSize      ; ELSE ; Self:FontSize      := ::oParent:FontSize()      ; ENDIF
 IF VALTYPE( ::lFontBold )      != 'U'; Self:FontBold      := ::lFontBold      ; ELSE ; Self:FontBold      := ::oParent:FontBold()      ; ENDIF
 IF VALTYPE( ::lFontItalic )    != 'U'; Self:FontItalic    := ::lFontItalic    ; ELSE ; Self:FontItalic    := ::oParent:FontItalic()    ; ENDIF
 IF VALTYPE( ::lFontUnderline ) != 'U'; Self:FontUnderline := ::lFontUnderline ; ELSE ; Self:FontUnderline := ::oParent:FontUnderline() ; ENDIF
 IF VALTYPE( ::lFontStrikeout ) != 'U'; Self:FontStrikeOut := ::lFontStrikeout ; ELSE ; Self:FontStrikeOut := ::oParent:FontStrikeout() ; ENDIF
 IF VALTYPE( ::nHeight )        != 'U'; Self:Height        := ::nHeight        ; ENDIF
 IF VALTYPE( ::nRow )           != 'U'; Self:Row           := ::nRow           ; ENDIF
 IF VALTYPE( ::cStyleSheet )    != 'U'; Self:StyleSheet    := ::cStyleSheet    ; ENDIF
 IF VALTYPE( ::nWidth )         != 'U'; Self:Width         := ::nWidth         ; ENDIF

// ::oQTObject:move( ::nCol , ::nRow )
// ::oQTObject:resize( ::nWidth, ::nHeight )
 ::oQTObject:setWindowTitle( ::cTitle )

// setup icon if valorized
 IF VALTYPE( ::cIcon ) == "C"
  ::oQTObject:setWindowIcon( ::cIcon )
 ENDIF

// Create system tray icon
 ::oSystemTrayIcon := QSystemTrayIcon( ::oQTObject )

// Events connection
 IF VALTYPE( ::bOnRelease ) == "B"
  IF ::nFormType == LFRM_MAIN
   ::oQTObject:connect( QEvent_Close , {|| EVAL( ::bOnRelease ), ::LAPPLICATION():Quit() } )
  ELSE
   ::oQTObject:connect( QEvent_Close , {|| EVAL( ::bOnRelease ), ::oQTObject:Exit(), ::oQTObject:Quit() } )
  ENDIF
 ENDIF

// create child controls
 ::CreatePendingChildControls()

// Execute OnInit Block
 IF VALTYPE( ::bOnInit ) == "B"
  EVAL( ::bOnInit )
 ENDIF

// Set the focus policy to capture focus and keyboard events.
 IF ::oQTObject:focusPolicy() == Qt_NoFocus
  ::oQTObject:setFocusPolicy( Qt_StrongFocus )
 ENDIF


// Show QtObject
 ::oQTObject:Show()

// Start Qt handling
 ::sQtApplication:exec()

RETURN NIL

/*---------------------------------------------------------------
 CreatePendingChildControls
 ---------------------------------------------------------------*/
METHOD LFORMS:CreatePendingChildControls()

 LOCAL nI

// Create Child Controls
 FOR nI := 1 TO LEN( ::aControls )
  IF ::aControls[nI]:lQtObject == .F.
   ::aControls[nI]:Create()
  ENDIF
 NEXT nI

RETURN NIL

/*---------------------------------------------------------------
 New
 ---------------------------------------------------------------*/
METHOD LFORMS:New( cName )

 ::oDefaultParent := Self
 ::oParent        := ::oApplParent

 IF HB_ISCHAR( cName ) == .F.
  ::nObjectCounter++
  cName := "form" + hb_ntos( ::nObjectCounter )
 ENDIF
 ::cName          := cName

// Add form object to windows: class
 ::oParent:AddForm( ::cName, Self )

RETURN Self

/*---------------------------------------------------------------
 Release
 ---------------------------------------------------------------*/
METHOD LFORMS:Release()

 LOCAL cFormName := ::cName

 IF ::lQtObject
  ::oQTObject:close()
  ::oApplParent:&cFormName := NIL
 ENDIF

RETURN NIL
