/*
  Llabel class
*/
#include "hbclass.ch"
#include "common.ch"
#include "hbqtgui.ch"

CLASS LLABEL FROM LCORE, LAPPLICATION

// Properties
 METHOD Direction                               SETGET
 METHOD Halign                                  SETGET
 METHOD Valign                                  SETGET

// Events

// Methods
 METHOD Create
 METHOD New

ENDCLASS

/*................................................................
 Properties - section
 ................................................................*/

/*---------------------------------------------------------------
 Direction
 ---------------------------------------------------------------*/
METHOD LLABEL:Direction( nArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::nDirection
  ELSEIF VALTYPE( nArg1 ) == "N"
   IF nArg1 == Qt_AlignAbsolute
    ::nDirection := nArg1
    ::oQTObject:SetAlignment( hb_bitOR( ::nHalign, ::nValign, ::nDirection ) )
   ENDIF
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::nDirection
  ELSEIF VALTYPE( nArg1 ) == "N"
   IF nArg1 == Qt_AlignAbsolute
    ::nDirection := nArg1
   ENDIF
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Halign
 ---------------------------------------------------------------*/
METHOD LLABEL:Halign( nArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::nHalign
  ELSEIF VALTYPE( nArg1 ) == "N"
   IF nArg1 == Qt_AlignLeft .OR. nArg1 == Qt_AlignRight .OR. nArg1 == Qt_AlignHCenter .OR. nArg1 == Qt_AlignJustify
    ::nHalign := nArg1
    ::oQTObject:SetAlignment( hb_bitOR( ::nHalign, ::nValign, ::nDirection ) )
   ENDIF
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::nHalign
  ELSEIF VALTYPE( nArg1 ) == "N"
   IF nArg1 == Qt_AlignLeft .OR. nArg1 == Qt_AlignRight .OR. nArg1 == Qt_AlignHCenter .OR. nArg1 == Qt_AlignJustify
    ::nHalign := nArg1
   ENDIF
  ENDIF
 ENDIF

RETURN NIL

/*---------------------------------------------------------------
 Valign
 ---------------------------------------------------------------*/
METHOD LLABEL:Valign( nArg1 )

 IF ::lQtObject
  IF PCOUNT() == 0
   RETURN ::nValign
  ELSEIF VALTYPE( nArg1 ) == "N"
   IF nArg1 == Qt_AlignTop .OR. nArg1 == Qt_AlignBottom .OR. nArg1 == Qt_AlignVCenter
    ::nValign := nArg1
    ::oQTObject:SetAlignment( hb_bitOR( ::nHalign, ::nValign, ::nDirection ) )
   ENDIF
  ENDIF
 ELSE
  IF PCOUNT() == 0
   RETURN ::nValign
  ELSEIF VALTYPE( nArg1 ) == "N"
   IF nArg1 == Qt_AlignTop .OR. nArg1 == Qt_AlignBottom .OR. nArg1 == Qt_AlignVCenter
    ::nValign := nArg1
   ENDIF
  ENDIF
 ENDIF

RETURN NIL

/*................................................................
 Methods - section
 ................................................................*/

/*---------------------------------------------------------------
 Create
 ---------------------------------------------------------------*/
METHOD LLABEL:Create()

 IF ::lQtObject == .T.
  RETURN NIL
 ENDIF

 ::lQtObject := .T.
 // Create QtObject
 ::oQTObject := QLabel( ::oParent:Qtobject() )

// setup font
 ::oFont := ::oParent:Font()
 IF VALTYPE( ::cCaption )       != 'U'; Self:Caption       := ::cCaption       ; ENDIF
 IF VALTYPE( ::nCol )           != 'U'; Self:Col           := ::nCol           ; ENDIF
 IF VALTYPE( ::cFontName )      != 'U'; Self:FontName      := ::cFontName      ; ELSE ; Self:FontName      := ::oParent:FontName()      ; ENDIF
 IF VALTYPE( ::nFontSize )      != 'U'; Self:FontSize      := ::nFontSize      ; ELSE ; Self:FontSize      := ::oParent:FontSize()      ; ENDIF
 IF VALTYPE( ::lFontBold )      != 'U'; Self:FontBold      := ::lFontBold      ; ELSE ; Self:FontBold      := ::oParent:FontBold()      ; ENDIF
 IF VALTYPE( ::lFontItalic )    != 'U'; Self:FontItalic    := ::lFontItalic    ; ELSE ; Self:FontItalic    := ::oParent:FontItalic()    ; ENDIF
 IF VALTYPE( ::lFontUnderline ) != 'U'; Self:FontUnderline := ::lFontUnderline ; ELSE ; Self:FontUnderline := ::oParent:FontUnderline() ; ENDIF
 IF VALTYPE( ::lFontStrikeout ) != 'U'; Self:FontStrikeOut := ::lFontStrikeout ; ELSE ; Self:FontStrikeOut := ::oParent:FontStrikeout() ; ENDIF
 IF VALTYPE( ::nHeight )        != 'U'; Self:Height        := ::nHeight        ; ENDIF
 IF VALTYPE( ::nRow )           != 'U'; Self:Row           := ::nRow           ; ENDIF
 IF VALTYPE( ::cStyleSheet )    != 'U'; Self:StyleSheet    := ::cStyleSheet    ; ENDIF
 IF VALTYPE( ::nWidth )         != 'U'; Self:Width         := ::nWidth         ; ENDIF

 ::oQTObject:show()

RETURN NIL

/*---------------------------------------------------------------
 New
 ---------------------------------------------------------------*/
METHOD LLABEL:New( cName )

 ::oParent        := ::oDefaultParent

 IF HB_ISCHAR( cName ) == .F.
  ::nObjectCounter++
  cName := "label" + hb_ntos( ::nObjectCounter )
 ENDIF
 ::cName          := cName

// Add form object to windows: class
 ::oParent:AddObject( ::cName, Self )

RETURN Self
